include("init.jl")

mutable struct E_coli_Model

    S::Matrix
    c::Vector
    LB::Vector
    UB::Vector
    Rxnames::Vector
    v::Vector

    function E_coli_Model(S::Matrix, c::Vector, LB::Vector, UB::Vector, Rxnames::Vector)
        v = zeros(size(S)[2])
        new(S, c, LB, UB, Rxnames, v)
    end
end

# Print fluxes
# ---------------------------------------------------------------------
function printFluxes(model::Any, print_all::Any)
    println("Fluxes:")
    println("----------------------------------------------")
    for i = 1:length(model.v)
        if print_all == false
            if (abs(model.v[i]) > 1e-5)
                println("$(model.Rxnames[i]): $(model.v[i])")
            end
        else
            println("$(model.Rxnames[i]): $(model.v[i])")
        end
    end
end

# Change reaction bounds
# ---------------------------------------------------------------------
function changeRxnBounds(model::Any, rec_target::String, val_target::Any, bound_target::String)
    for i = 1:length(model.v)
        if model.Rxnames[i] == rec_target
            if bound_target == "l"
                model.LB[i] = val_target
            elseif bound_target == "u"
                model.UB[i] = val_target
            else
                println("l for lower bound and u for upper bound")
            end
            return nothing
        end
    end
end

E_coli_Model_init = E_coli_Model(init_mod[:S], init_mod[:c], init_mod[:LB], init_mod[:UB], init_mod[:Rxnames])