# include("MPC/Test control parameters/main.jl")

import Ipopt, JuMP, Plots

include("E. coli model/E_coli_Model.jl")
include("init.jl")
include("DA.jl")
include("P-Duality1.jl")
include("P-Duality2.jl")
include("P-Duality3.jl")

# Initialize model:
mod = E_coli_Model_init
changeRxnBounds(mod, "EX_o2(e)", v_omax , "l")

t_0 = 0   # h
t_end = 30 # h
N = 30 
dt = (t_end-t_0)/N
sp = 0.3*ones(1,N+1) #[0.3*ones(1,5) 0.35*ones(1,13) 0.3*ones(1,13)]#0.3*ones(1,N+1)#
G_f  = G_f0*ones(1,N+1)

time = Array{Float64}(undef, N+1)
time[1] = t_0

# P. Dual 1:
G_Dual =    Array{Float64}(undef, N+1)
X_Dual =    Array{Float64}(undef, N+1)
A_Dual =    Array{Float64}(undef, N+1)
D_Dual =    Array{Float64}(undef, N+1)
status_Dual =  Array{Any}(undef, N)
time_Dual = Array{Float64}(undef, N)
t_list_Dual = [t_0]
G_list_Dual = [G_0]
X_list_Dual = [X_0]
A_list_Dual = [A_0]

G_Dual[1]    = G_0
X_Dual[1]    = X_0
A_Dual[1]    = A_0
D_Dual[1]    = D_0

# P. Dual 2:
G_PDual =    Array{Float64}(undef, N+1)
X_PDual =    Array{Float64}(undef, N+1)
A_PDual =    Array{Float64}(undef, N+1)
D_PDual =    Array{Float64}(undef, N+1)
status_PDual =  Array{Any}(undef, N)
time_PDual = Array{Float64}(undef, N)
t_list_PDual = [t_0]
G_list_PDual = [G_0]
X_list_PDual = [X_0]
A_list_PDual = [A_0]

G_PDual[1]    = G_0
X_PDual[1]    = X_0
A_PDual[1]    = A_0
D_PDual[1]    = D_0

# P. Dual 3:
G_PKKT =    Array{Float64}(undef, N+1)
X_PKKT =    Array{Float64}(undef, N+1)
A_PKKT =    Array{Float64}(undef, N+1)
D_PKKT =    Array{Float64}(undef, N+1)
time_PKKT = Array{Float64}(undef, N)
status_PKKT =  Array{Any}(undef, N)
t_list_PKKT = [t_0]
G_list_PKKT = [G_0]
X_list_PKKT = [X_0]
A_list_PKKT = [A_0]

G_PKKT[1]    = G_0
X_PKKT[1]    = X_0
A_PKKT[1]    = A_0
D_PKKT[1]    = D_0

# MSE
MSE_Dual = 0
MSE_PDual = 0
MSE_PKKT = 0

for n = 1:N
    global t_list_Dual, G_list_Dual, X_list_Dual, A_list_Dual, t_list_PDual, G_list_PDual, X_list_PDual, A_list_PDual, t_list_PKKT, G_list_PKKT, X_list_PKKT, A_list_PKKT, MSE_Dual, MSE_PDual, MSE_PKKT,status_Dual, status_PDual, status_PKKT ,time_Dual,time_PDual,time_PKKT
    
    display(n)

    # MPC optimizations: 
    time[n+1] = time[n]+dt
    D_Dual[n+1], status_Dual[n], time_Dual[n] = PDual1(mod, G_Dual[n], X_Dual[n], A_Dual[n], K_g, v_gmax, 4, D_Dual[n], G_f[n], sp[n])
    D_PDual[n+1], status_PDual[n], time_PDual[n] = PDual2(mod, G_PDual[n], X_PDual[n], A_PDual[n], K_g, v_gmax, 4, D_PDual[n], G_f[n], sp[n])
    D_PKKT[n+1], status_PKKT[n], time_PKKT[n] = PDual3(mod, G_PKKT[n], X_PKKT[n], A_PKKT[n], K_g, v_gmax, 4, D_PKKT[n], G_f[n], sp[n])
    
    # P. Dual 1:
    G_Dual[n+1], X_Dual[n+1], A_Dual[n+1], C_t, C_G, C_X, C_A = DAP(mod, G_Dual[n], X_Dual[n], A_Dual[n], K_g, v_gmax, v_omax, time[n], time[n+1], D_Dual[n+1], G_f[n])
    t_list_Dual = vcat(t_list_Dual, C_t)
    G_list_Dual = vcat(G_list_Dual, C_G)
    X_list_Dual = vcat(X_list_Dual, C_X)
    A_list_Dual = vcat(A_list_Dual, C_A)

    # P. Dual 2:
    G_PDual[n+1], X_PDual[n+1], A_PDual[n+1], C_t, C_G, C_X, C_A = DAP(mod, G_PDual[n], X_PDual[n], A_PDual[n], K_g, v_gmax, v_omax, time[n], time[n+1], D_PDual[n+1], G_f[n])
    t_list_PDual = vcat(t_list_PDual, C_t)
    G_list_PDual = vcat(G_list_PDual, C_G)
    X_list_PDual = vcat(X_list_PDual, C_X)
    A_list_PDual = vcat(A_list_PDual, C_A)
    
    # P. Dual 3:
    G_PKKT[n+1], X_PKKT[n+1], A_PKKT[n+1], C_t, C_G, C_X, C_A = DAP(mod, G_PKKT[n], X_PKKT[n], A_PKKT[n], K_g, v_gmax, v_omax, time[n], time[n+1], D_PKKT[n+1], G_f[n])
    t_list_PKKT = vcat(t_list_PKKT, C_t)
    G_list_PKKT = vcat(G_list_PKKT, C_G)
    X_list_PKKT = vcat(X_list_PKKT, C_X)
    A_list_PKKT = vcat(A_list_PKKT, C_A)

    # MSE:
    MSE_Dual = MSE_Dual + (X_Dual[n]- sp[n])^2
    MSE_PDual = MSE_PDual + (X_PDual[n]- sp[n])^2
    MSE_PKKT = MSE_PKKT + (X_PKKT[n]- sp[n])^2
end

# Calculate MSE:
MSE_Dual = MSE_Dual + (X_Dual[N+1]- sp[N+1])^2
MSE_PDual = MSE_PDual + (X_PDual[N+1]- sp[N+1])^2
MSE_PKKT = MSE_PKKT + (X_PKKT[N+1]- sp[N+1])^2

# Display results: 
display("Status:")
display("P. Dual 1:")
for i in status_Dual
    if i != "Solve_Succeeded"
        display(i)
    end
end
display("P. Dual 2:")
for i in status_PDual
    if i != "Solve_Succeeded"
        display(i)
    end
end
display("P. Dual 3:")
for i in status_PKKT
    if i != "Solve_Succeeded"
        display(i)
    end
end

display("MSE:")
display(MSE_Dual/(N+1))
display(MSE_PDual/(N+1))
display(MSE_PKKT/(N+1))

display("Time:")
display(sum(time_Dual)/N)
display(sum(time_PDual)/N)
display(sum(time_PKKT)/N)

# Ploting results:
using Plots

pG =  plot(t_list_Dual,G_list_Dual, title="Glucose", xaxis="Time [h]",yaxis="Concentration [mmol/L]", label="C = 1000", lw=2, ls=:solid, color=:orange)
pG =  plot!(t_list_PDual,G_list_PDual, label="C = 1", lw=2, ls=:dash, color=:green)
pG =  plot!(t_list_PKKT,G_list_PKKT, label="C = 0.001", lw=2, ls=:dot, color=:red)

pX =  plot(t_list_Dual,X_list_Dual, title="Biomass", xaxis="Time [h]",yaxis="Concentration [g/L]", label="C = 1000", lw=2, ls=:solid, color=:orange)
pX =  plot!(t_list_PDual,X_list_PDual, label="C = 1", lw=2, ls=:dash, color=:green)
pX =  plot!(t_list_PKKT,X_list_PKKT, label="C = 0.001", lw=2, ls=:dot, color=:red)
pX =  plot!(time, sp[1,:], label="Set point", lw=2, ls=:dash, color=:blue, linetype=:steppost)

pA =  plot(t_list_Dual,A_list_Dual, title="Acetate", xaxis="Time [h]",yaxis="Concentration [mmol/L]", label="C = 1000", lw=2, ls=:solid, color=:orange)
pA =  plot!(t_list_PDual,A_list_PDual, label="C = 1", lw=2, ls=:dash, color=:green)
pA =  plot!(t_list_PKKT,A_list_PKKT, label="C = 0.001", lw=2, ls=:dot, color=:red)

pD =  plot(time, D_Dual, title="Dilution rate", xaxis="Time [h]",yaxis="Dilution rate [h^-1]", label="C = 1000", lw=2, ls=:solid, color=:orange, linetype=:steppost)
pD =  plot!(time,D_PDual, label="C = 1", lw=2, ls=:dash, color=:green, linetype=:steppost)
pD =  plot!(time, D_PKKT, label="C = 0.001", lw=2, ls=:dot, color=:red, linetype=:steppost)

# Save plots:
savefig(pG,"MPC-C-G.pdf")
savefig(pX,"MPC-C-X.pdf")
savefig(pA,"MPC-C-A.pdf")
savefig(pD,"MPC-C-D.pdf")
