# include("SS-model/main - D.jl")

import Ipopt, JuMP, Plots, TimerOutputs

include("E. coli core/E_coli_Model.jl")
include("init.jl")

include("Methods/Duality.jl")
include("Methods/PDuality.jl")
include("Methods/PKKT.jl")

timer = TimerOutputs.TimerOutput()

# Initialize model:
mod = E_coli_Model_init # E. coli model - core metabolism
changeRxnBounds(mod, "EX_o2(e)", v_omax , "l")

D = 0.744

display("Dual")
TimerOutputs.reset_timer!(timer)
G_Dual, X_Dual, A_Dual, status_Dual = Dual(mod, G_0, X_0, A_0, K_g, v_gmax)
display(timer)

display(status_Dual)
display(G_Dual)
display(X_Dual)
display(A_Dual)

display("P. Dual")
TimerOutputs.reset_timer!(timer)
G_PDual, X_PDual, A_PDual, status_PDual = PDual(mod, G_0, X_0, A_0, K_g, v_gmax)
display(timer)

display(status_PDual)
display(G_PDual)
display(X_PDual)
display(A_PDual)

display("P. KKT")
TimerOutputs.reset_timer!(timer)
G_PKKT, X_PKKT, A_PKKT, status_PKKT = PKKT(mod, G_0, X_0, A_0, K_g, v_gmax)
display(timer)

display(status_PKKT)
display(G_PDual)
display(X_PDual)
display(A_PDual)
