# include("pFBA reformulations comperison/main.jl")

import JuMP, Ipopt, Printf

include("E. coli model/E_coli_model.jl")
include("pFBA reformulations/optimizers.jl")
include("MSE.jl")

model = E_coli_Model_init
changeRxnBounds(model, "EX_o2(e)", -30, "l")
changeRxnBounds(model, "EX_glc(e)", -10, "l")

T = 10
time = Matrix(undef, 14, T)
status = Matrix(undef, 14, T)

for t = 1:T
    global v_pFBA, v_pDual, v_PpDual, v_PpDual2, v_pKKT, v_PpKKT, v_PpKKT2
    
    # pFBA:
    v_pFBA, time[8,t], status[8,t] = pFBA(model)
    v_pDual, time[9,t], status[9,t] = Dual(model)
    v_PpDual, time[10,t], status[10,t] = PDual(model)
    v_PpDual2, time[11,t], status[11,t] = PDual2(model)
    v_pKKT, time[12,t], status[12,t] = KKT(model)
    v_PpKKT, time[13,t], status[13,t] = PKKT(model)
    v_PpKKT2, time[14,t], status[14,t] = PKKT2(model)
end

# Calculate MSE:

MSE_pDAP_pDual = MSE(v_pFBA, v_pDual)
MSE_pDAP_PpDual = MSE(v_pFBA, v_PpDual)
MSE_pDAP_PpDual2 = MSE(v_pFBA, v_PpDual2)
MSE_pDAP_pKKT = MSE(v_pFBA, v_pKKT)
MSE_pDAP_PpKKT = MSE(v_pFBA, v_PpKKT)
MSE_pDAP_PpKKT2 = MSE(v_pFBA, v_PpKKT2)

display("pFBA")
display(round(sum(time[8,:])/T, digits=3))
display(v_pFBA[13])
display(status[8])

display("Dual")
display(round(sum(time[9,:])/T, digits=3))
display(-v_pDual[13]+v_pFBA[13])
display(MSE_pDAP_pDual)
display(status[9])

display("P. Dual")
display(round(sum(time[10,:])/T, digits=3))
display(-v_PpDual[13]+v_pFBA[13])
display(MSE_pDAP_PpDual)
display(status[10])

display("P. Dual2")
display(round(sum(time[11,:])/T, digits=3))
display(-v_PpDual2[13]+v_pFBA[13])
display(MSE_pDAP_PpDual2)
display(status[11])

display("KKT")
display(round(sum(time[12,:])/T, digits=3))
display(-v_pKKT[13]+v_pFBA[13])
display(MSE_pDAP_pKKT)
display(status[12])

display("P. KKT")
display(round(sum(time[13,:])/T, digits=3))
display(-v_PpKKT[13]+v_pFBA[13])
display(MSE_pDAP_PpKKT)
display(status[13])

display("P. KKT2")
display(round(sum(time[14,:])/T, digits=3))
display(-v_PpKKT2[13]+v_pFBA[13])
display(MSE_pDAP_PpKKT2)
display(status[14])
